{% extends "materiel.html" %}
{% load static cache mathfilters humanize icon %}

{% block title %}
Demande d'emprunt
{% endblock %}

{% block content %}

<header>
    <h1>Demande d'emprunt</h1>
    <div class="header-content">
        <p class="card-text">
            Choisissez le matériel que vous souhaitez emprunter.
            {% if PERMANENCE %}
            Vous pouvez récupérer du matériel réservé à notre local, {{ PERMANENCE }}.
            {% endif %}
            <span class="d-block d-md-none">Cliquez sur une catégorie pour consulter le matériel disponible.</span>
        </p>

        {% if tache %}
        <div class="alert alert-success" role="alert">
            Votre emprunt sera relié à la tâche <strong>{{ tache.nom }}</strong> du projet
            <strong>{{ tache.projet.nom }}</strong>.
        </div>
        {% endif %}
        <div id="alerts" style="display: none">
            {% for alert in alerts %}
            <div class="alert alert-{{ alert.type }}" role="alert">
                <strong>{{ alert.titre }}</strong>{{ alert.contenu }}
            </div>
            {% endfor %}
        </div>
    </div>
</header>


<div class="container-fluid">
    <form class="needs-validation" id="demande-emprunt" method="post"
          {% if not tache %}
          action="{% url 'emprunt' %}">
        {% else %}
        action="{% url 'emprunt' tache.id %}">
        {% endif %}
        {% csrf_token %}

        <div class="row main-row">
            <div class="col-md-3 side-col">
                <div class="sticky">
                    <h2 class="title">Dates d'emprunt</h2>

                    <div class="form-group date">
                        {{ form.debut.label_tag }}
                        <div class="input-group">
                            <div class="input-group-prepend">
                                <span class="input-group-text"><i class="far fa-calendar"></i></span>
                            </div>
                            {{ form.debut }}
                            <div class="invalid-feedback">
                                Date au format JJ/MM/AAAA HH:mm
                            </div>
                        </div>
                    </div>

                    <div class="form-group date">
                        {{ form.fin.label_tag }}
                        <div class="input-group">
                            <div class="input-group-prepend">
                                <span class="input-group-text"><i class="far fa-calendar"></i></span>
                            </div>
                            {{ form.fin }}
                            <div class="invalid-feedback">
                                Date au format JJ/MM/AAAA HH:mm
                            </div>
                        </div>
                    </div>

                    <p class="alert alert-danger" id="alerte-dates-egales" style="display: none">
                        Merci d'indiquer des dates qui ne sont pas <strong>égales</strong> !
                    </p>
                    <p class="alert alert-danger" id="alerte-dates-inversees" style="display: none">
                        Le <strong>début</strong> de votre emprunt a lieu après la <strong>fin</strong> !
                    </p>
                    <p class="alert alert-danger" id="alerte-dates-anciennes" style="display: none">
                        Votre emprunt est dans le <strong>passé</strong> !
                    </p>
                    <p class="alert alert-danger" id="alertes-no-date" style="display: none">
                        Veuillez rentrer une date !
                    </p>


                    <hr>

                    <h2 class="title">Commentaire</h2>

                    <section>
                        {{ form.raison.label_tag }}
                        <div class="input-group form-group" id="raison">
                            {{ form.raison }}
                            <div class="invalid-feedback">
                                Ce champ est requis !
                            </div>
                        </div>
                    </section>

                    <div class="row">
                        <div class="col-md-12 text-center">
                            {% if perms.utilisateur.emprunt_gratuit %}
                            <button type="button" id="valider" class="btn btn-primary btn-xs" onclick="envoyer()">
                                Valider la demande
                            </button>
                            {% else %}
                            <button type="button" id="valider" class="btn btn-primary btn-xs" onclick="envoyer()"
                                    data-toggle="confirmation"
                                    data-btn-ok-label="Je comprends que la demande est payante"
                                    data-btn-cancel-label="Annuler" data-btn-cancel-class="btn-light"
                                    data-title="Attention ! Vous réservez une location payante de matériel.">
                                Valider la demande
                            </button>
                            {% endif %}
                            <input type="hidden" name="next" id="next"
                                   value="{% url 'accueil' modal_emprunt_reussi=True %}"/>
                        </div>
                    </div>
                </div>
            </div>


            <div class="col-md-9">

                <h2 class="title">Matériel</h2>

                <input id="searchbar" name="searchbar" class="form-control"
                       type="text" placeholder="Rechercher du matériel"/>

                <section id="materiel-results">
                    {% for type, materielsType in materiels.items %}
                    <section class="materialType">
                        <a class="switch" data-toggle="collapse" data-target="#{{ type }}"><h3 class="title"><i
                                class="fas fa-angle-right"></i> {{ type }}</h3></a>
                        <div id="{{ type }}" class="collapse">
                            {% for matos in materielsType %}
                            <div class="card card-lg materialItem">
                                <div class="card-body">
                                    <div class="row" id="row-{{ matos.materiel.id }}">
                                        <input type="checkbox" name="materiel" value="{{ matos.materiel.id }}"
                                               autocomplete="off" hidden/>
                                        <div class="col-md-2">
                                            <img class="photo-matos"
                                                 src="{% url 'photo_materiel' matos.materiel.id %}"
                                                 name="{{ matos.materiel.id }}"
                                                 alt="Photo du {{ matos.materiel.nom }}"/>
                                        </div>
                                        <div class="col-md-8">
                                            <h4 class="materialItemTitle">{{ matos.materiel.nom }}</h4>
                                            <p>Propiétaire: {{ matos.materiel.proprietaireMatos }}</p>
                                            <p id="matos-description-{{ matos.materiel.id }}"
                                               class="materialItemDescription">
                                                {{ matos.materiel.description|truncatechars:"150" }}
                                                {% if matos.materiel.description|length > 150 %}
                                                <a onclick="show_more({{ matos.materiel.id }})">Voir
                                                    plus</a>
                                                {% endif %}
                                            </p>
                                            <p>
                                                {% if not matos.emprunt_gratuit %}
                                            <p><strong>
                                                {% icon "treso" %} L'emprunt de ce matériel est payant !
                                            </strong></p>
                                            <p>
                                                Prix: {{ matos.materiel.prixLocation|floatformat:2|intcomma }}€/jour</p>
                                            <a href="#">Voir les tarifs</a>
                                            {% endif %}
                                            </p>
                                            <div class="row">
                                                <div class="col-md-5">
                                                    <label class="col-form-label"
                                                           for="quantite-{{ matos.materiel.id }}">
                                                        Quantité<span style='display: none;'
                                                                      id="quantite-restante-{{ matos.materiel.id }}"></span>
                                                        :
                                                    </label>
                                                </div>
                                                <div class="col-md-3">
                                                    <select class="form-control quantite-materiel"
                                                            id="quantite-{{ matos.materiel.id }}"
                                                            name="quantite-{{ matos.materiel.id }}">
                                                    </select>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="col-md-2">
                                            <button type="button" name="{{ matos.materiel.id }}"
                                                    class="btn btn-primary btn-matos disabled"
                                                    onclick="reserver({{ matos.materiel.id }})">Réserver
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            {% endfor %}
                        </div>
                    </section>
                    {% empty %}
                    <p>
                        Il n'y a pas de materiel. Ce n'est sans doute pas normal.<br/>
                        Merci de contacter un administrateur au plus vite à l'adresse {{ CONTACT_EMAIL }} !
                    </p>
                    {% endfor %}
                </section>
            </div>
        </div>
    </form>
</div>
{% endblock %}

{% block footer_javascript %}
{# Date time picker #}
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/moment.min.js"></script>
<script type="text/javascript"
        src="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.0.0/js/tempusdominus-bootstrap-4.min.js"></script>
<link rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.0.0/css/tempusdominus-bootstrap-4.min.css"/>
<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/locale/fr.js"></script>

{# Plugin confirmation box #}
<script src="https://cdn.jsdelivr.net/npm/bootstrap-confirmation2@4.0.0/dist/bootstrap-confirmation.min.js"></script>

<script type="text/javascript" src="{% static 'materiel/js/emprunt.js' %}?v=7"></script>
<script type="text/javascript">
        let url_emprunt_disponibilite = '{% url 'emprunt_disponibilite' %}';
        let url_materiel_description = '{% url 'materiel_description' %}';
        $('#searchbar').on('input', (e) => {
                    searchForMateriel(e.target.value.toLowerCase())
                });


</script>
{% endblock %}
